#ifndef UNICODE
#define UNICODE
#endif 

#include "CEveOnlineAPI.hpp"
#include <string>
#include <windows.h>
#include <Wininet.h>
#include <iostream>
#include <fstream>
#include "API_URLs.hpp"
#pragma comment(lib, "wininet.lib")
#include <Windowsx.h>
#include "tinyxml2.h"
#include <vector>
#include <commctrl.h>
#pragma comment(lib, "comctl32.lib")

int iFenster = 0;

#define MENU_EXIT_BUTTON 1;
#define MENU_SETTINGS_BUTTON 2;

// Register the window class.
const wchar_t CLASS_NAME[] = L"TheChecker";
const wchar_t CLASS_NAME_CHILD[] = L"Child";


struct HandleStorage{
	std::vector<HWND> vHandlePtr;
	std::vector<std::wstring> vHandleName;
};

HandleStorage Test;

HWND Childhwnd = 0;

std::wstring APIKeyInput;
std::wstring VeriCodeInput;

// function forward declaration

DWORD Error = 0;


LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK WindowChildProc(HWND Childhwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

BOOL DrawMenu(HWND hwnd);

HFONT DefaultFont = CreateFont(18, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, L"Comic Sans");



int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE, PWSTR pCmdLine, int nCmdShow)
{
	// Define a structure to hold some state information.
	InitCommonControls();
	WNDCLASS wc = {};

	wc.lpfnWndProc = WindowProc;
	wc.hInstance = hInstance;
	wc.lpszClassName = CLASS_NAME;
	RegisterClass(&wc);
	// Create the window.

	
	
	
	
	HWND hwnd = CreateWindowEx(
		0,                              // Optional window styles.
		CLASS_NAME,                     // Window class
		L"Learn to Program Windows",    // Window text
		WS_OVERLAPPEDWINDOW,            // Window style
		CW_USEDEFAULT,					// Size and position
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		NULL,							// Parent window    
		NULL,							// Menu
		hInstance,						// Instance handle
		NULL							// Additional application data
		);
    
	if (hwnd == NULL)
	{
		return 0;
	}


	// Define a structure to hold some state information.


	WNDCLASS wcc = {};

	wcc.lpfnWndProc = WindowChildProc;
	wcc.hInstance = hInstance;
	wcc.lpszClassName = CLASS_NAME_CHILD;

	RegisterClass(&wcc);

	ShowWindow(hwnd, nCmdShow);
    MSG msg = { };
    while (GetMessage(&msg, NULL, 0, 0))   // Run the message loop.
    {
		if (msg.hwnd == hwnd)
		{
			if (!IsDialogMessage(hwnd, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
		{
			if (!IsDialogMessage(Childhwnd, &msg))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
    }

    return 0;
}

LRESULT CALLBACK WindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)
    {
		case WM_CREATE:
		{
						  DrawMenu(hwnd);
						  return 0;
		}
		case WM_COMMAND:
		{
						   switch (wParam)
						   {
								case 2:
								{
										  SendMessage(hwnd, WM_CLOSE, wParam, NULL);
										  return 0;
								}
								case 1001:
								{
										  PostQuitMessage(0);
										  return 0;
								}
								case 1002:
								{  
										  Childhwnd = CreateWindowEx(
											  WS_EX_CONTROLPARENT,
											  CLASS_NAME_CHILD,                     // Window class
											  L"API Key Manager",    // Window text
											  WS_POPUPWINDOW | WS_CAPTION ,          // Window style
											  100,				// Size and position
											  100,
											  800,
											  250,
											  hwnd,							// Parent window    
											  NULL,							// Menu
											  (HINSTANCE)GetWindowLongPtr(hwnd, GWL_HINSTANCE),						// Instance handle
											  NULL							// Additional application data
											  );
										  ShowWindow(Childhwnd, SW_SHOW);
										  EnableWindow(hwnd , false);
										  return 0;

								}
								case 3:
								{
										  return 0;
								}
								case 11:
								{
										   return 0;
								}
						   }
						   return 0;
		}
		case WM_DESTROY:
		{
			PostQuitMessage(0);
			return 0;
		}
		case WM_PAINT:
		{	
				PAINTSTRUCT ps;
				HDC hdc = BeginPaint(hwnd, &ps);
				FillRect(hdc, &ps.rcPaint, (HBRUSH) (COLOR_WINDOW+1));
				EndPaint(hwnd, &ps);
				return 0;
        }
		case WM_CLOSE:
		{
						 switch (wParam)
						 {
							case 2:
							{
									if (MessageBox(hwnd, L"Really quit?", L"My application", MB_OKCANCEL) == IDOK)
									{
										DestroyWindow(hwnd);
									}// Else: User canceled. Do nothing.
									return 0;
							}
							case 1001:
							{
								   PostQuitMessage(0);
								   return 0;
							}
						 }
						 
						 
			if (MessageBox(hwnd, L"Really quit?", L"My application", MB_OKCANCEL) == IDOK)
			{
				DestroyWindow(hwnd);
			}// Else: User canceled. Do nothing.
			 return 0;
		}
    }
    return DefWindowProc(hwnd, uMsg, wParam, lParam);
}

BOOL DrawMenu(HWND hwnd){

	HMENU hMenuBar = CreateMenu();
	HMENU hFile = CreateMenu();
	HMENU hOptions = CreateMenu();
	AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR)hFile, L"Datei");
	AppendMenu(hMenuBar, MF_POPUP, (UINT_PTR)hOptions, L"Optionen");
	AppendMenu(hFile, MF_STRING, 1001, L"Schlieen");
	AppendMenu(hOptions, MF_STRING, 1002, L"API Einstellungen");
	SetMenu(hwnd, hMenuBar);

	return 0;
}



LRESULT CALLBACK WindowChildProc(HWND Childhwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
	{				  // Variablen fr die Positionierung der E/A-Objekte
					  int iInputOffsetx = 20;
					  int iInputOffsety = 80;
					  int iButtonOffsetx = 410;
					  int iButtonOffsety = 150;
					  int iButtonWidth = 100;
					  int iButtonHeight = 30;
					  // Verzweigung fr Febsterdarstellung (Step1, Step2, etc.)
					  switch (iFenster)
					  {
					  case 0: // Zeiche Buttons
					  {
								  HWND hwndButton_BACK = CreateWindow(
									  L"BUTTON",  // Predefined class; Unicode assumed 
									  L"BACK",      // Button text 
									  WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | WS_TABSTOP,  // Styles 
									iButtonOffsetx,         // x position 
									iButtonOffsety,         // y position 
									iButtonWidth,           // Button width
									iButtonHeight,          // Button height
									Childhwnd,     // Parent window
									(HMENU)10,       // edit control ID.
									(HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
									NULL);      // Pointer not needed.

								HWND hwndButton_NEXT = CreateWindow(
									L"BUTTON",  // Predefined class; Unicode assumed 
									L"Next",      // Button text 
									WS_VISIBLE | WS_CHILD | BS_DEFPUSHBUTTON | WS_TABSTOP,  // Styles 
									iButtonOffsetx + (iButtonWidth + 20),         // x position 
									iButtonOffsety,         // y position 
									iButtonWidth,           // Button width
									iButtonHeight,          // Button height
									Childhwnd,     // Parent window
									(HMENU)11,       // edit control ID.
									(HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
									NULL);      // Pointer not needed.
								

								HWND hwndButton_CANCEL = CreateWindow(
									L"BUTTON",  // Predefined class; Unicode assumed 
									L"CANCEL",      // Button text 
									WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | WS_TABSTOP,  // Styles 
									iButtonOffsetx + 2 * (iButtonWidth + 20),         // x position 
									iButtonOffsety,         // y position 
									iButtonWidth,           // Button width
									iButtonHeight,          // Button height
									Childhwnd,     // Parent window
									(HMENU)12,       // edit control ID.
									(HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
									NULL);      // Pointer not needed.
								iFenster = 1;
								SendMessage(Childhwnd, WM_CREATE, NULL, NULL);
								return 0;
					  }
					  case 1: // API Key Eingabemaske
					  {
					  HWND hwndStatic_API_Key = CreateWindowEx(
						  NULL,
						  L"Static",   // predefined class 
						  L"API Key:",         // no window title 
						  WS_CHILD | WS_VISIBLE | ES_RIGHT,
						  iInputOffsetx, // set size in WM_SIZE message 
						  iInputOffsety,
						  120,
						  20,
						  Childhwnd,         // parent window 
						  (HMENU)13,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed

					  HWND hwndStatic_VeriCode = CreateWindowEx(
						  NULL,
						  L"Static",   // predefined class 
						  L"Verification Code:",         // no window title 
						  WS_CHILD | WS_VISIBLE | ES_RIGHT,
						  iInputOffsetx, // set size in WM_SIZE message 
						  iInputOffsety+30,
						  120,
						  20,
						  Childhwnd,         // parent window 
						  (HMENU)14,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed

					  HWND hwndEdit_API_Key = CreateWindowEx(
						  WS_EX_CLIENTEDGE,
						  L"EDIT",   // predefined class 
						  (LPCWSTR)APIKeyInput.c_str(),         // no window title 
						  WS_CHILD | WS_VISIBLE | WS_TABSTOP,
						  iInputOffsetx+130, // set size in WM_SIZE message 
						  iInputOffsety, 
						  200, 
						  20,   
						  Childhwnd,         // parent window 
						  (HMENU)15,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed 

					  HWND hwndEdit_VeriCode = CreateWindowEx(
						  WS_EX_CLIENTEDGE,
						  L"EDIT",   // predefined class 
						  NULL,         // no window title 
						  WS_CHILD | WS_VISIBLE | WS_TABSTOP,
						  iInputOffsetx+130, // set size in WM_SIZE message 
						  iInputOffsety+30, 
						  550, 
						  20, 
						  Childhwnd,         // parent window 
						  (HMENU)16,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed
					  SetFocus(hwndEdit_VeriCode);
					  HWND hwndEdit_InfoText = CreateWindowEx(
						  NULL,
						  L"Static",   // predefined class 
						  L"Please enter your API Key information.",         // no window title 
						  WS_CHILD | WS_VISIBLE,
						  iInputOffsetx, // set size in WM_SIZE message 
						  iInputOffsety - 30,
						  550,
						  20,
						  Childhwnd,         // parent window 
						  (HMENU)17,   // edit control ID 
						  (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
						  NULL);        // pointer not needed


					  EnableWindow(GetDlgItem(Childhwnd, 10), false); // Back Button abschalten
					  
					  return 0;
					  }
					  case 2:  // Anzeige Account Name und verfgbare Chars
					  {
								EnableWindow(GetDlgItem(Childhwnd, 10), true);

								HWND hwndEdit_InfoText = CreateWindowEx(
									NULL,
									L"STATIC",   // predefined class 
									L"The following charakters were found on this API Key:",         // no window title 
									WS_CHILD | WS_VISIBLE,
									iInputOffsetx, // set size in WM_SIZE message 
									iInputOffsety - 30,
									550,
									20,
									Childhwnd,         // parent window 
									(HMENU)17,   // edit control ID 
									(HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
									NULL);        // pointer not needed
								return 0;
					  }
					  case 3:  // Zeige Zusammenfassung
					  {
								   SetWindowText(GetDlgItem(Childhwnd, 11), L"Speichern");

								   HWND hwndEdit_InfoText = CreateWindowEx(
									   NULL,
									   L"STATIC",   // predefined class 
									   L"Testseite",         // no window title 
									   WS_CHILD | WS_VISIBLE,
									   iInputOffsetx, // set size in WM_SIZE message 
									   iInputOffsety - 30,
									   550,
									   20,
									   Childhwnd,         // parent window 
									   (HMENU)17,   // edit control ID 
									   (HINSTANCE)GetWindowLong(Childhwnd, GWL_HINSTANCE),
									   NULL);        // pointer not needed
								   return 0;
					  }

					  }


	}
	case WM_COMMAND:
	{
					   switch (LOWORD(wParam))
					   {
					   case 10:   
					   {          // ein Fenster zurck
								  iFenster--;
								  SendMessage(Childhwnd, WM_CREATE, NULL, NULL);
								  return 0;
					   }
					   case 11:
							{
								  switch (iFenster) // Verzweigung zum Aufrumen
								  {
								  case 1:   // API Key Eingabe aufrumen
								  {
											DestroyWindow(GetDlgItem(Childhwnd, 13));
											DestroyWindow(GetDlgItem(Childhwnd, 14));
											SendMessage(GetDlgItem(Childhwnd, 15), WM_GETTEXT, (WPARAM)10, (LPARAM)APIKeyInput.c_str());
											DestroyWindow(GetDlgItem(Childhwnd, 15));
											SendMessage(GetDlgItem(Childhwnd, 16), WM_GETTEXT, (WPARAM)65, (LPARAM)VeriCodeInput.c_str());
											DestroyWindow(GetDlgItem(Childhwnd, 16));
											DestroyWindow(GetDlgItem(Childhwnd, 17));
											iFenster++;

											SendMessage(Childhwnd, WM_CREATE, NULL, NULL);
											return 0;
								  }
								  case 2:   // Char bersicht aufrumen
								  {
											DestroyWindow(GetDlgItem(Childhwnd, 17));
											iFenster++;
											SendMessage(Childhwnd, WM_CREATE, NULL, NULL);
											return 0;
								  }
								  case 3:   // Char bersicht aufrumen
								  {
											DestroyWindow(GetDlgItem(Childhwnd, 17));
											iFenster++;
											SendMessage(Childhwnd, WM_CLOSE, NULL, NULL);
											return 0;
								  }
								  }
								 
							}
					   case 12:
							{
								 SendMessage(Childhwnd, WM_CLOSE, NULL, NULL);
								 return 0;
							}
					   }
					   return 0;
	}
	case WM_DESTROY:
	{
					   return 0;
	}
	case WM_PAINT:
	{
					 PAINTSTRUCT ps;
					 HDC hdc = BeginPaint(Childhwnd, &ps);
					 FillRect(hdc, &ps.rcPaint, (HBRUSH)(COLOR_WINDOW));
					 EndPaint(Childhwnd, &ps);
					 return 0;
	}
	case WM_CLOSE:
	{
					 iFenster = 0;
					 EnableWindow(GetParent(Childhwnd), true);
					 DestroyWindow(Childhwnd);
					 return 0;
	}
	}
	return DefWindowProc(Childhwnd, uMsg, wParam, lParam);
}

